
package de.ivu.elect.presentation.kandidatur;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.kandidatur.boundary.ErsatzkandidaturBoundaryCreate;
import de.ivu.elect.business.kandidatur.boundary.ErsatzkandidaturFactory;
import de.ivu.elect.business.kandidatur.entity.Ersatzkandidatur;
import de.ivu.elect.business.kandidatur.entity.ErsatzkandidaturMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractErsatzkandidaturCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractErsatzkandidaturCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.ERSATZKANDIDATUR_CREATE)
public abstract class AbstractErsatzkandidaturCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<Ersatzkandidatur> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "ersatzkandidaturCreateView";

  public static final String VIEW_ID = "/kandidatur/ersatzkandidatur-create.xhtml";

  public static final String PARENT_VIEW_ID = "/kandidatur/ersatzkandidatur-search.xhtml";

  @Inject
  protected transient ErsatzkandidaturBoundaryCreate create;

  protected Ersatzkandidatur entity;

  @Inject
  protected transient ErsatzkandidaturMeta entityMeta;

  
  @Inject
  protected transient ErsatzkandidaturFactory factory;

  public AbstractErsatzkandidaturCreateNoScopeView() {
    super();
  }

  @PostConstruct
  public void init() {
    setEntity(factory.create());
  }

  

  public Ersatzkandidatur getEntity() {
    return entity;
  }

  protected void setEntity(Ersatzkandidatur entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.ERSATZKANDIDATUR_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Ersatzkandidatur entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(Ersatzkandidatur entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.ERSATZKANDIDATUR_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
